//
//	cz http header
//
#ifndef __czhttp_h
#define __czhttp_h

#include <wininet.h>
#define INETBUF_MAX 4096

enum {
CZHTTP_MODE_NONE = 0,
CZHTTP_MODE_READY,
CZHTTP_MODE_REQUEST,
CZHTTP_MODE_REQSEND,
CZHTTP_MODE_DATAWAIT,
CZHTTP_MODE_DATAEND,
CZHTTP_MODE_INFOREQ,
CZHTTP_MODE_INFORECV,
CZHTTP_MODE_FTPREADY,
CZHTTP_MODE_FTPDIR,
CZHTTP_MODE_FTPREAD,
CZHTTP_MODE_FTPWRITE,
CZHTTP_MODE_FTPCMD,
CZHTTP_MODE_FTPRESULT,
CZHTTP_MODE_ERROR,
CZHTTP_MODE_VARREQUEST,
CZHTTP_MODE_VARREQSEND,
CZHTTP_MODE_VARDATAWAIT,
CZHTTP_MODE_VARDATAEND,
CZHTTP_MODE_MAX
};

class CzHttp {
public:
	CzHttp();
	~CzHttp();
	void Terminate( void );
	void Reset( void );
	int Exec( void );									// t[ƂɌĂ΂
	int GetMode( void ) { return mode; };				// ݂̃[hԂ
	char *GetError( void );								// G[̃|C^擾
	int RequestFile( char *path );						// T[o[Ƀt@Cv
	char *RequestFileInfo( char *path );				// T[o[Ƀt@Cv
	void SetURL( char *url );							// T[o[URLݒ
	void SetLocalName( char *name );					// _E[hݒ
	int GetSize( void );								// 擾t@C̃TCYԂ
	char *GetData( void );								// 擾t@Cf[^ւ̃|C^Ԃ
	void SetAgent( char *agent );						// G[WFg̐ݒ
	void SetProxy( char *url, int port, int local );	// vLV̐ݒ
	void SetHeader( char *header );						// wb_̐ݒ
	void SetUserName( char *name );						// [U[̐ݒ
	void SetUserPassword( char *pass );					// pX[h̐ݒ
	void SetFtpPort( int port );						// |[g̐ݒ

	void SetVarRequestGet( char *path );
	void SetVarRequestPost( char *path, char *post );
	void ClearVarData( void );
	void SetVarServerFromURL( void );
	char *getVarData( void ) { return vardata; };
	int	getVarSize( void ) { return varsize; };

	int FtpConnect( void );								// FTPڑ
	void FtpDisconnect( void );							// FTPؒf
	char *GetFtpResponse( void );						// FTPX|Xւ̃|C^Ԃ
	char *GetFtpCurrentDir( void );						// FTPJgfBNg擾
	void SetFtpDir( char *name );						// FTPJgfBNgύX
	void GetFtpDirList( void );							// FTPJgfBNge擾
	int KillFtpDir( char *name );						// FTPfBNg폜
	int MakeFtpDir( char *name );						// FTPfBNg쐬
	int GetFtpFile( char *name, char *downname, int tmode );	// FTPt@C擾
	int PutFtpFile( char *name, char *downname, int tmode );	// FTPt@CM
	int RenameFtpFile( char *name, char *newname );		// FTPt@Cl[
	int FtpSendCommand( char *cmd );					// FTPR}hM

	char *GetTempBuffer( void );						// obt@ւ̃|C^Ԃ
	char *GetFlexBuffer( void ) { return pt; };			// σobt@ւ̃|C^Ԃ

	int UrlEncode( char *dst, int dstsize, char *src );	// URLGR[h
	int UrlDecode( char *dst, int dstsize, char *src );	// URLfR[h


private:
	void SetError( char *mes );	

	void ResetFlexBuf( int defsize );
	void AllocFlexBuf( int size );
	void AddFlexBuf( char *data, int size );
	int GetFlexBufSize( void ) { return pt_cur; };
	int CheckHexCode( int code );

	HINTERNET hSession;
	HINTERNET hService;
    HINTERNET hFtpEnum;
    HINTERNET hResponse;
    WIN32_FIND_DATA	finddata;

	HINTERNET hHttpSession;
	HINTERNET hHttpRequest;

	char *str_agent;		// User Agent (optonal)
	int mode;				// Current Mode
	int size;				// File Size

	char *pt;				// Memory Ptr
	int pt_cur;				// Flax Mem Size ( Current )
	int pt_size;			// Flax Mem Size ( Allocated )

	FILE *fp;
	int proxy_local;		// ProxyLocal flag
	int ftp_port;			// Ftp port

	char req_url[1024];		// Request URL
	char req_url2[1024];	// Request URL (for POST/GET)
	char req_path[512];		// Request PATH
	char down_path[512];	// Download PATH
	char proxy_url[1024];	// Proxy URL
	char *req_header;		// Request Header (optonal)
	char username[256];		// User Name string buffer
	char userpass[256];		// User Pass string buffer
	char buf[INETBUF_MAX];	// temp
	char errstr[256];		// Error string buffer

	char varserver[256];	// VarRequest server name
	char varstr[256];		// VarRequest request token
	INTERNET_PORT varport;	// VarRequest server port
	char *postdata;			// Post data
	char *vardata;			// Transfer destination
	int varsize;			// Transfer max size
};


#endif
